﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MindFusion.UI.WinForms;
using System.Runtime.InteropServices;

namespace DockControl
{
    public partial class MainForm : Form
    {
        DockItem tabItem;
        DockItem propertiesItem;
        DockItem solutionItem;
        DockItem toolBoxItem;
        DockItem pendingItem;
        DockItem errorItem;
        DockItem findSymbol;

        public MainForm()
        {
            InitializeComponent();

            tabItem = new DockItem() { Header = "Tabbed Document", Id = "TabbedDocument" };
            tabItem.DockStyle = DockStyle.Fill;
            tabItem.Content = GetContent("Tabbed Document");
            dockControl1.Items.Add(tabItem);

            propertiesItem = new DockItem() { Header = "Properties", Icon = Properties.Resources.topic, Id = "Properties" };
            propertiesItem.DockStyle = DockStyle.Left;
            propertiesItem.Content = GetContent("Properties");
            dockControl1.Items.Add(propertiesItem);

            solutionItem = new DockItem() { Header = "Solution Explorer", Icon = Properties.Resources.bookclosed, Id = "SolutionExplorer" };
            solutionItem.DockStyle = DockStyle.Fill;
            solutionItem.DockParent = propertiesItem;
            solutionItem.Content = GetContent("Solution Explorer");
            dockControl1.Items.Add(solutionItem);

            toolBoxItem = new DockItem() { Header = "Toolbox", Id = "Toolbox" };
            toolBoxItem.DockStyle = DockStyle.Right;
            toolBoxItem.Content = GetContent("Toolbox");
            dockControl1.Items.Add(toolBoxItem);

            pendingItem = new DockItem() { Header = "Pending Checkins", Id = "PendingCheckins" };
            pendingItem.DockStyle = DockStyle.Bottom;
            pendingItem.Content = GetContent("Pending Checkins");
            pendingItem.Size = new Size(200, 200);
            dockControl1.Items.Add(pendingItem);
            pendingItem.Size = new Size(0, 0);

            errorItem = new DockItem() { Header = "Error List", Id = "ErrorList" };
            errorItem.DockStyle = DockStyle.Fill;
            errorItem.DockParent = pendingItem;
            errorItem.Content = GetContent("Error List");
            dockControl1.Items.Add(errorItem);

            findSymbol = new DockItem() { Header = "Find Symbol Results", Id = "FindSymbolResults" };
            findSymbol.DockStyle = DockStyle.Bottom;
            findSymbol.DockParent = toolBoxItem;
            findSymbol.Content = GetContent("Find Symbol Results");
            dockControl1.Items.Add(findSymbol);

            dockControl1.ItemLoading += new EventHandler<ItemContentEventArgs>(dockControl1_ItemLoading);

            /* add your license key to disable trial mode 
            MindFusion.Licensing.LicenseManager.AddLicense("Your-License-Key-Here");
             * */
        }

        void dockControl1_ItemLoading(object sender, ItemContentEventArgs e)
        {
            if (e.Item.Content == null)
            {
                if (e.Item.Id == "TabbedDocument")
                    e.Item.Content = GetContent("Tabbed Document");
                if (e.Item.Id == "Properties")
                    e.Item.Content = GetContent("Properties");
                if (e.Item.Id == "SolutionExplorer")
                    e.Item.Content = GetContent("Solution Explorer");
                if (e.Item.Id == "Toolbox")
                    e.Item.Content = GetContent("Toolbox");
                if (e.Item.Id == "PendingCheckins")
                    e.Item.Content = GetContent("Pending Checkins");
                if (e.Item.Id == "ErrorList")
                    e.Item.Content = GetContent("Error List");
                if (e.Item.Id == "FindSymbolResults")
                    e.Item.Content = GetContent("Find Symbol Results");
            }
        }

        private Control GetContent(string contentType)
        {
            Control control = null;

            if (contentType == "Solution Explorer")
            {
                BufferedTreeView treeView = GetTreeView();
                treeView.Nodes.Add(new TreeNode() { Text = "Properties", ImageIndex = 0, SelectedImageIndex = 0 });
                treeView.Nodes.Add(new TreeNode() { Text = "References", ImageIndex = 0, SelectedImageIndex = 0 });
                treeView.Nodes.Add(new TreeNode() { Text = "Resources", ImageIndex = 0, SelectedImageIndex = 0 });
                treeView.Nodes.Add(new TreeNode() { Text = "MainForm", ImageIndex = 0, SelectedImageIndex = 0 });
                treeView.Nodes.Add(new TreeNode() { Text = "Program", ImageIndex = 2, SelectedImageIndex = 2 });
                for (int i = 0; i < treeView.Nodes.Count; i++)
                {
                    TreeNode node = treeView.Nodes[i];
                    if (i == 0)
                    {
                        node.Nodes.Add(new TreeNode() { Text = "AssemblyInfo.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "Resources.resx", ImageIndex = 0, SelectedImageIndex = 0 });
                        node.Nodes.Add(new TreeNode() { Text = "Settings.settings", ImageIndex = 0, SelectedImageIndex = 0 });
                        for (int j = 1; j < node.Nodes.Count; j++)
                        {
                            TreeNode jNode = node.Nodes[j];
                            if (j == 1)
                                jNode.Nodes.Add(new TreeNode() { Text = "Resources.Designer.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                            if (j == 2)
                                jNode.Nodes.Add(new TreeNode() { Text = "Settings.Designer.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                        }
                        node.Expand();
                    }
                    if (i == 1)
                    {
                        node.Nodes.Add(new TreeNode() { Text = "MindFusion.UI.WinForms", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "System", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "System.Core", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "System.Data", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "System.Data.SetExtensions", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "System.Deployment", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "System.Drawing", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "System.Windows.Forms", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "System.Xml", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "System.Xml.Linq", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Expand();
                    }
                    if (i == 2)
                    {
                        node.Nodes.Add(new TreeNode() { Text = "bookclosed.png", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "bookopen.png", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "topic.png", ImageIndex = 2, SelectedImageIndex = 2 });
                    }
                    if (i == 3)
                    {
                        node.Nodes.Add(new TreeNode() { Text = "MainForm.Designer.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "MainForm.resx", ImageIndex = 2, SelectedImageIndex = 2 });
                    }
                }

                control = treeView;
            }
            if (contentType == "Properties")
            {
                PropertyGrid grid = new PropertyGrid();
                grid.Margin = new Padding(0);
                grid.SelectedObject = dockControl1;
                control = grid;
            }
            if (contentType == "Tabbed Document")
            {
                Label label = new Label();
                label.Padding = new Padding(10);
                label.BorderStyle = BorderStyle.None;
                label.Margin = new Padding(0);
                label.Text = "This sample illustrates the docking component. Various windows are initially docked to the sides of the container. The windows can be docked and undocked interactively by clicking on their headers with the mouse and dragging.";
                label.BackColor = Color.White;
                control = label;
            }
            if (contentType == "Error List")
            {
                
                MenuStrip strip = new MenuStrip();
                strip.Dock = DockStyle.Top;
                strip.Items.Add("0 Errors");
                strip.Items.Add("0 Warnings");
                strip.Items.Add("0 Messages");

                BufferedListView view = new BufferedListView();
                view.View = View.Details;
                view.Margin = new Padding(0);
                view.BorderStyle = BorderStyle.None;
                view.Dock = DockStyle.Fill;
                view.Columns.Add(new ColumnHeader() { Width = 250, Text = "Description" });
                view.Columns.Add(new ColumnHeader() { Width = 120, Text = "File" });
                view.Columns.Add(new ColumnHeader() { Width = 50, Text = "Line" });
                view.Columns.Add(new ColumnHeader() { Width = 50, Text = "Column" });
                view.Columns.Add(new ColumnHeader() { Width = 120, Text = "Project" });
                view.SizeChanged += new EventHandler(view_SizeChanged);

                ListViewItem item1 = new ListViewItem("Only assignment, call, increment, decrement, and new object expressions can be used as a statement MainForm.cs	134	91	DockControl");

                item1.SubItems.Add("MainForm.cs");
                item1.SubItems.Add("134");
                item1.SubItems.Add("91");
                item1.SubItems.Add("DockControl");

                ListViewItem item2 = new ListViewItem("Argument missing");
                item2.SubItems.Add("MainForm.cs");
                item2.SubItems.Add("147");
                item2.SubItems.Add("41");
                item2.SubItems.Add("DockControl");

                ListViewItem item3 = new ListViewItem("The name 'x' does not exist in the current context");
                item3.SubItems.Add("MainForm.cs");
                item3.SubItems.Add("150");
                item3.SubItems.Add("41");
                item3.SubItems.Add("DockControl");

                view.Items.AddRange(new ListViewItem[] { item1, item2, item3 });
                view.SizeChanged += new EventHandler(view_SizeChanged);

                Panel panel = new Panel();
                panel.Margin = new Padding(0);
                panel.Controls.Add(strip);
                panel.Controls.Add(view);
                view.BringToFront();
                panel.SizeChanged += new EventHandler(view_SizeChanged);

                control = panel;
            }
            if (contentType == "Toolbox")
            {
                Label label = new Label();
                label.Padding = new Padding(10);
                label.BorderStyle = BorderStyle.None;
                label.Margin = new Padding(0);
                label.Text = "There are no usable controls in this group.Drag an item into this text to add it to the toolbox.";
                label.BackColor = Color.White;
                control = label;             
            }
            if (contentType == "Pending Checkins")
            {
                MenuStrip strip = new MenuStrip();
                strip.Dock = DockStyle.Top;
                strip.Items.Add("Name");
                strip.Items.Add("Change type");




                BufferedTreeView treeView = GetTreeView();
                treeView.Dock = DockStyle.Fill;
                treeView.Nodes.Add(new TreeNode() { Text = "Project1", ImageIndex = 0, SelectedImageIndex = 0 });
                treeView.Nodes.Add(new TreeNode() { Text = "Project2", ImageIndex = 0, SelectedImageIndex = 0 });                           
                for (int i = 0; i < treeView.Nodes.Count; i++)
                {
                    TreeNode node = treeView.Nodes[i];
                    if (i == 0)
                    {
                        node.Nodes.Add(new TreeNode() { Text = "Class1.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "Class2.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "Class3.cs", ImageIndex = 2, SelectedImageIndex = 2 });                        
                        node.Expand();
                    }
                    if (i == 1)
                    {
                        node.Nodes.Add(new TreeNode() { Text = "Class1.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "Class2.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "Class3.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "Class4.cs", ImageIndex = 2, SelectedImageIndex = 2 });
                        node.Nodes.Add(new TreeNode() { Text = "Class5.cs", ImageIndex = 2, SelectedImageIndex = 2 });                     
                        node.Expand();
                    }                   
                }





                Panel panel = new Panel();
                panel.Margin = new Padding(0);
                panel.Controls.Add(strip);
                panel.BackColor = Color.White;
                panel.Controls.Add(treeView);
                panel.ParentChanged += new EventHandler(panel_ParentChanged);
                treeView.BringToFront();
                control = panel;
            }
            if (contentType == "Find Symbol Results")
            {
                Label label = new Label();
                label.Padding = new Padding(10);
                label.BorderStyle = BorderStyle.None;
                label.Margin = new Padding(0);
                label.Text = "<Empty Content>";
                label.BackColor = Color.White;
                control = label;  
            }
           
            return control;
        }

        void panel_ParentChanged(object sender, EventArgs e)
        {
            (sender as Control).Update();
            (sender as Control).Refresh();
            foreach (Control s in (sender as Control).Controls)
                s.Refresh();
        }         

        void view_SizeChanged(object sender, EventArgs e)
        {
            (sender as Control).Update();            
        }

        private BufferedTreeView GetTreeView()
        {
            BufferedTreeView treeView = new BufferedTreeView();
            treeView.Margin = new Padding(0, 0, 0, 0);
            treeView.BorderStyle = BorderStyle.None;
            treeView.Margin = new Padding(0);
            treeView.Padding = new Padding(0, 200, 0, 0);
            treeView.AfterExpand += new TreeViewEventHandler(OnTreeViewAfterExpand);
            treeView.AfterCollapse += new TreeViewEventHandler(OnTreeViewAfterCollapse);

            ImageList list = new ImageList();
            list.Images.Add(Properties.Resources.bookclosed);
            list.Images.Add(Properties.Resources.bookopen);
            list.Images.Add(Properties.Resources.topic);
            treeView.ImageList = list;

            return treeView;
        }

        private void OnTreeViewAfterCollapse(object sender, TreeViewEventArgs e)
        {
            e.Node.ImageIndex = 0;
            e.Node.SelectedImageIndex = 0;
        }

        private void OnTreeViewAfterExpand(object sender, TreeViewEventArgs e)
        {
            e.Node.ImageIndex = 1;
            e.Node.SelectedImageIndex = 1;
        }

        private void tabToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool enter = false;
            foreach (DockItem item in dockControl1.Items)
            {
                if (item.Id == "TabbedDocument")
                    enter = true;
            }
            if (!enter)
                dockControl1.Items.Add(tabItem);
        }

        private void propertiesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool enter = false;
            foreach (DockItem item in dockControl1.Items)
            {
                if (item.Id == "Properties")
                    enter = true;
            }
            if (!enter)
            {
                dockControl1.Items.Add(propertiesItem);
            }
        }

        private void solutionExplorerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool enter = false;
            foreach (DockItem item in dockControl1.Items)
            {
                if (item.Id == "SolutionExplorer")
                    enter = true;
            }
            if (!enter)
                dockControl1.Items.Add(solutionItem);
        }

        private void toolboxToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool enter = false;
            foreach (DockItem item in dockControl1.Items)
            {
                if (item.Id == "Toolbox")
                    enter = true;
            }
            if (!enter)
                dockControl1.Items.Add(toolBoxItem);
        }

        private void pendingChekinsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool enter = false;
            foreach (DockItem item in dockControl1.Items)
            {
                if (item.Id == "PendingCheckins")
                    enter = true;
            }
            if (!enter)
                dockControl1.Items.Add(pendingItem);
        }

        private void errorListToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool enter = false;
            foreach (DockItem item in dockControl1.Items)
            {
                if (item.Id == "ErrorList")
                    enter = true;
            }
            if (!enter)
                dockControl1.Items.Add(errorItem);
        }

        private void findSymbolResultsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool enter = false;
            foreach (DockItem item in dockControl1.Items)
            {
                if (item.Id == "FindSymbolResults")
                    enter = true;
            }
            if (!enter)
                dockControl1.Items.Add(findSymbol);
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dockControl1.SaveToXml("SaveXml");
        }

        private void loadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dockControl1.LoadFromXml("SaveXml");
        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.FindForm().Close();
        }

        private void dockControl1_Load(object sender, EventArgs e)
        {

        }      
    }

    internal class BufferedTreeView : TreeView
    {
        protected override void OnHandleCreated(EventArgs e)
        {
            SendMessage(this.Handle, TVM_SETEXTENDEDSTYLE, (IntPtr)TVS_EX_DOUBLEBUFFER, (IntPtr)TVS_EX_DOUBLEBUFFER);
            base.OnHandleCreated(e);
        }
        // Pinvoke:
        private const int TVM_SETEXTENDEDSTYLE = 0x1100 + 44;
        private const int TVM_GETEXTENDEDSTYLE = 0x1100 + 45;
        private const int TVS_EX_DOUBLEBUFFER = 0x0004;
        [DllImport("user32.dll")]
        private static extern IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wp, IntPtr lp);
    }

    internal class BufferedListView : ListView
    {
        protected override void OnHandleCreated(EventArgs e)
        {
            SendMessage(this.Handle, TVM_SETEXTENDEDSTYLE, (IntPtr)TVS_EX_DOUBLEBUFFER, (IntPtr)TVS_EX_DOUBLEBUFFER);
            base.OnHandleCreated(e);
        }
        // Pinvoke:
        private const int TVM_SETEXTENDEDSTYLE = 0x1100 + 44;
        private const int TVM_GETEXTENDEDSTYLE = 0x1100 + 45;
        private const int TVS_EX_DOUBLEBUFFER = 0x0004;
        [DllImport("user32.dll")]
        private static extern IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wp, IntPtr lp);
    }
}
